// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::Checker;
use glib::{prelude::*, translate::*};
use std::{fmt, ptr};

glib::wrapper! {
    #[doc(alias = "GspellNavigator")]
    pub struct Navigator(Interface<ffi::GspellNavigator, ffi::GspellNavigatorInterface>);

    match fn {
        type_ => || ffi::gspell_navigator_get_type(),
    }
}

impl Navigator {
    pub const NONE: Option<&'static Navigator> = None;
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::Navigator>> Sealed for T {}
}

pub trait NavigatorExt: IsA<Navigator> + sealed::Sealed + 'static {
    #[doc(alias = "gspell_navigator_change")]
    fn change(&self, word: &str, change_to: &str) {
        unsafe {
            ffi::gspell_navigator_change(
                self.as_ref().to_glib_none().0,
                word.to_glib_none().0,
                change_to.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "gspell_navigator_change_all")]
    fn change_all(&self, word: &str, change_to: &str) {
        unsafe {
            ffi::gspell_navigator_change_all(
                self.as_ref().to_glib_none().0,
                word.to_glib_none().0,
                change_to.to_glib_none().0,
            );
        }
    }

    #[doc(alias = "gspell_navigator_goto_next")]
    fn goto_next(&self) -> Result<(glib::GString, Checker), glib::Error> {
        unsafe {
            let mut word = ptr::null_mut();
            let mut spell_checker = ptr::null_mut();
            let mut error = ptr::null_mut();
            let is_ok = ffi::gspell_navigator_goto_next(
                self.as_ref().to_glib_none().0,
                &mut word,
                &mut spell_checker,
                &mut error,
            );
            debug_assert_eq!(is_ok == glib::ffi::GFALSE, !error.is_null());
            if error.is_null() {
                Ok((from_glib_full(word), from_glib_full(spell_checker)))
            } else {
                Err(from_glib_full(error))
            }
        }
    }
}

impl<O: IsA<Navigator>> NavigatorExt for O {}

impl fmt::Display for Navigator {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("Navigator")
    }
}
